// Objects used in the public HTTP API.

package api

type FingerprintRequest struct {
	Fingerprints []string `json:"fingerprints"`
}

type FingerprintResponse struct {
	Missing []string `json:"missing"`
	Dupes   []string `json:"dupes"`
}

type UploadResponse struct {
	Ok bool `json:"ok"`
}

type SearchIdsResponse struct {
	Results []string `json:"results"`
}

type SearchResponse struct {
	Results []*Song `json:"results"`
}

type GetManySongsRequest struct {
	SongIds []string `json:"song_ids"`
}

type GetManySongsResponse struct {
	Results []*Song `json:"results"`
}

type AddPlayLogRequest struct {
	Songs []string `json:"songs"`
}

type SuggestRequest struct {
	CurrentSongs []string `json:"current_songs"`
	SkipGlobal   bool
}

type SuggestResponse struct {
	SongIds []string `json:"song_ids"`
}
