package api

import (
	"testing"
)

func TestSongToDoc_Artist(t *testing.T) {
	af := &AudioFile{
		MD5:      "12345",
		MimeType: "audio/mpeg",
		Size:     1234,
		SongId:   "12345",
	}
	meta := &Meta{
		Artist: "Victor Hugo",
		Year:   1862,
	}
	song := NewSong(af, meta)
	doc := song.ToDoc()

	artist := doc["artist"]
	if artist == nil || len(artist) != 3 {
		t.Fatalf("artist: %v", artist)
	}
	if artist[0] != "victor" {
		t.Errorf("artist[0]: %v", artist[0])
	}
	if artist[1] != "hugo" {
		t.Errorf("artist[1]: %v", artist[1])
	}
	if artist[2] != "=Victor Hugo" {
		t.Errorf("artist[2]: %v", artist[2])
	}

	year := doc["year"]
	if year == nil || len(year) != 1 {
		t.Fatalf("year: %v", year)
	}
	if year[0] != "1862" {
		t.Errorf("year[0]: %v", year[0])
	}
}
