package upload

import (
	"log"
	"os"
)

func IsFileUnchanged(fileinfo *FileInfo) bool {
	curInfo, err := os.Stat(fileinfo.Path)
	if err != nil {
		log.Printf("Couldn't stat %s: %s", fileinfo.Path, err.Error())
		return false
	}

	// Verify that the file size and mtime still match: this should
	// hopefully catch files that are still being written to.
	if curInfo.ModTime() != fileinfo.Info.ModTime() || curInfo.Size() != fileinfo.Info.Size() {
		log.Printf("File %s changed while looking at it", fileinfo.Path)
		return false
	}

	return true
}
