package upload

import (
	"log"

	"git.autistici.org/ale/djrandom/util"
)

func NewMimeTypeFilterFunc(acceptedTypes []string) func(*FileInfo) bool {
	fn := func(fileinfo *FileInfo) bool {
		mimeType, err := util.GetMimeTypeOfFile(fileinfo.Path)
		if err != nil {
			return false
		}
		log.Printf("%s: %s", fileinfo.Path, mimeType)
		fileinfo.Meta["mime-type"] = mimeType
		return MatchAny(mimeType, acceptedTypes)
	}
	return fn
}
