package index

import (
	"log"
	"testing"
)

func stqCompareSlices(a, b []string) bool {
	if len(a) != len(b) {
		return false
	}
	for i := 0; i < len(a); i++ {
		if a[i] != b[i] {
			return false
		}
	}
	return true
}

func TestStringToQuery_Default(t *testing.T) {
	ast := StringToQuery("chet")
	if ast == nil {
		t.Fatalf("nil ast")
	}

	// This query will set multiple indexes.
	s := ast.String()
	log.Println(s)

	// for _, idx := range queryDefaultIndexes {
	// 	if _, ok := q.Query[idx]; !ok {
	// 		t.Fatalf("Index '%s' not set: %v", idx, q)
	// 	}
	// 	if val := q.Query[idx][0]; val != "chet" {
	// 		t.Fatalf("Query parsed incorrectly: %s = %v", idx, val)
	// 	}
	// }
}

func TestStringToQuery_Default_TwoWords(t *testing.T) {
	ast := StringToQuery("chet baker")
	if ast == nil {
		t.Fatalf("nil ast")
	}

	// This query will set multiple indexes.
	s := ast.String()
	log.Println(s)

	// This query will set multiple indexes.
	// expectedWords := []string{"chet", "baker"}
	// for _, idx := range queryDefaultIndexes {
	// 	w, ok := q.Query[idx]
	// 	if !ok {
	// 		t.Fatalf("Index '%s' not set: %v", idx, q)
	// 	}
	// 	if !stqCompareSlices(w, expectedWords) {
	// 		t.Fatalf("Query parsed incorrectly: %s = %v", idx, w)
	// 	}
	// }
}

func TestStringToQuery_Keyword(t *testing.T) {
	ast := StringToQuery("artist:\"chet baker\"")
	if ast == nil {
		t.Fatalf("nil ast")
	}

	log.Println(ast.String())

	// if _, ok := q.Query["artist"]; !ok {
	// 	t.Fatalf("Index 'artist' not set: %v", q)
	// }
	// if val := q.Query["artist"][0]; val != "chet baker" {
	// 	t.Fatalf("Query parsed incorrectly: artist = %v", val)
	// }
}

func TestStringToQuery_Mixed(t *testing.T) {
	ast := StringToQuery("tokyo artist:\"chet baker\"")
	if ast == nil {
		t.Fatalf("nil ast")
	}

	log.Println(ast.String())

	// Just check a single index.
	// expected := []string{"tokyo", "chet baker"}
	// w, ok := q.Query["artist"]
	// if !ok {
	// 	t.Fatalf("Index 'artist' not set: %v", q)
	// }
	// if !stqCompareSlices(w, expected) {
	// 	t.Fatalf("Query parsed incorrectly: artist = %v", w)
	// }
}
