
djrandom.API = function(baseUrl) {

  // Perform the AJAX request to the API server.
  function doRequest(method, url, data, callback, errback) {
    $.ajax({
      url: baseUrl + url,
      type: method,
      data: data,
      dataType: 'json',
      error: function(jqxhr, textStatus, errorThrown) {
        errback(textStatus + ' ' + errorThrown);
      },
      success: function(data, textStatus, jqxhr) {
        callback(data);
      }
    });
  }

  // Select audio files that are appropriate for this interface
  // (specifically, mp3). This sets the 'song.audio_file' attribute
  // for later access.
  //
  // TODO: improve the selection by sorting by bitrate.
  function pickAudioFile(song) {
    for (var i = 0; i < song.files.length; i++) {
      var af = song.files[i];
      if (af.mime_type == "audio/mpeg") {
        song.audio_file = af;
        return af;
      }
    }
    return null;
  }

  this.Search = function(query, callback, errback) {
    doRequest('POST', 'api/search', {q: query}, function(data) {
      // Filter search results by calling pickAudioFile().
      var songs = [];
      for (var i = 0; i < data.results.length; i++) {
        var s = data.results[i];
        if (pickAudioFile(s)) {
          songs.push(s);
        }
      }
      callback(songs);
    }, errback);
  };

  this.AddToPlayLog = function(songs) {
    var data = JSON.stringify({Songs: songs});
    doRequest('POST', 'api/add_playlog', data, function(){}, function(){});
  };

  this.GetAlbumArtUrl = function(song) {
    return baseUrl + 'api/album_art?artist=' + encodeURIComponent(song.meta.artist) + '&album=' + encodeURIComponent(song.meta.album);
  };

};
