// Miscellaneous useful functions.

var delay = (function(){
  var timer = 0;
  return function(callback, ms){
    clearTimeout (timer);
    timer = setTimeout(callback, ms);
  };
})();

djrandom.windowResize = function() {
  delay(function() {
    // Resize the playlist view.
    // var plv = $('#playlist_view');
    // plv.height($(window).height() - 16 - plv.offset().top);

    // Recenter the player.
    var ploff = $(window).height() / 2 - 100;
    $('#player').css('margin-top', '' + ploff + 'px').show();
  }, 100);
};

// Initialize the UI.
djrandom.Init = function() {
  $(document).ready(function() {
    djrandom.api = new djrandom.API('/');
    djrandom.albumart = new djrandom.AlbumArt(djrandom.api);
    djrandom.player = new djrandom.Player();
    djrandom.player_ui = new djrandom.PlayerUI();
    djrandom.playlist = new djrandom.Playlist(djrandom.api, 'playlist');
    djrandom.search = new djrandom.Searcher(djrandom.api, 'searchForm');

    // Connect all components.
    // Player and PlayerUI.
    djrandom.player.on('play', function() {
      djrandom.player_ui.SetState(true);
    });
    djrandom.player.on('pause', function() {
      djrandom.player_ui.SetState(false);
    });
    djrandom.player_ui.on('play', function() {
      djrandom.player.Pause();
    });
    djrandom.player_ui.on('pause', function() {
      djrandom.player.Pause();
    });

    // Player and Playlist.
    djrandom.player.on('next', function() {
      djrandom.playlist.PlayNextSong();
    });
    djrandom.player.on('error', function() {
      console.log('error, skipping to next song...');
      djrandom.playlist.PlayNextSong();
    });
    djrandom.player.on('playing', function(song) {
      console.log('now playing "' + song.meta.title + '"');
      djrandom.albumart.Set(song);
    });
    djrandom.playlist.on('play', function(song) {
      djrandom.player.Play(song);
    });

    // Searcher and Playlist.
    djrandom.search.on('search', function(results) {
      $.each(results, function(idx, song) {
        djrandom.playlist.AddSong(song);
      });
      // Resize the scrollbar if necessary.
      // djrandom.windowResize();
    });

    // Set up other UI events, window resizes etc.
    djrandom.windowResize();
    $(window).resize(djrandom.windowResize);
  });
};
