package util

// RunAtOnce starts 'n' workers to run the specified function, and stream the
// results to a channel.  The channel will return exactly the same number of
// elements as there are in the input.
func RunAtOnce(n int, input []string, f func(string) interface{}) chan interface{} {

	c := make(chan string)
	rCh := make(chan interface{})

	go func() {
		for _, item := range input {
			c <- item
		}
		close(c)
	}()

	if n > len(input) {
		n = len(input)
	}
	for i := 0; i < n; i++ {
		go func() {
			for item := range c {
				rCh <- f(item)
			}
		}()
	}

	return rCh
}
