package util

import (
	"crypto/rand"
	"encoding/hex"
	"fmt"
	"os"
	"path/filepath"
	"time"
)

var (
	tmpdir = os.TempDir()
)

func TempName(prefix, suffix string) string {
	buf := make([]byte, 4)
	rand.Read(buf)
	return filepath.Join(
		tmpdir,
		fmt.Sprintf(
			"%s%d.%d.%s%s",
			prefix,
			os.Getpid(),
			time.Now().Unix(),
			hex.EncodeToString(buf),
			suffix))

}

func TempFile(prefix, suffix string) (*os.File, error) {
	return os.Create(TempName(prefix, suffix))
}
