package tokenizer

import (
	"testing"
)

func TestTokenizer_Tokenize(t *testing.T) {
	s := "the quick brown fox"
	result := Tokenize(s)
	if len(result) != 4 {
		t.Errorf("Unexpected result size %d (exp. 4)", len(result))
	}

	s = "Hello, 世界"
	result = Tokenize(s)
	if len(result) != 2 {
		t.Errorf("Unexpected result size %d (exp. 2)", len(result))
	}
	if len(result) > 0 && result[0] != "Hello" {
		t.Errorf("First token: %s", result[0])
	}
	if len(result) > 1 && result[1] != "世界" {
		t.Errorf("Second token: %s", result[1])
	}
}

func TestTokenizer_IsKeyword(t *testing.T) {
	s := "Hello, a!"
	result := TokenFilter(Tokenize(s), IsKeyword)
	if len(result) != 1 {
		t.Errorf("Unexpected result size %d (exp. 1)", len(result))
	}
	if len(result) > 0 && result[0] != "Hello" {
		t.Errorf("First token: %s", result[0])
	}
}
